/*
 * This file is part of the rtap localisation project.
 */

#ifndef _AP_H
#define _AP_H


#include "../../librtaputil/rtaputil.h"
#include <pcap.h>

// Pour la fonction get_mac_addr() :
#include <netinet/if_ether.h>
#include <netinet/tcp.h>
#include <netinet/ip.h>


/* Codes d'erreurs */
#define ERR_CREATING_SOCKET 1 // Erreur lors de la création de la socket d'envoi
#define ERR_OPENING_IFACE 2 // Erreur lors de l'ouverture de l'interface de capture
#define ERR_BAD_USAGE 3 // Mauvais appel au programme


/* Arguments du programme */
#define ARGC 4
enum {ARGV_AGGREG_IP=1, ARGV_RTAP_IFACE, ARGV_WIFI_IFACE} ;


/* En-têtes des fonctions */
void* keep_mode_monitor(char *iface) ;
int capture(char *capture_iface, char *aggregated_ip, BOOL print_values) ;
void read_packet(u_char *args, const struct pcap_pkthdr *header, const u_char *packet, int sockfd, struct sockaddr_in *server, BOOL print_values) ;
void get_mac_addr(char *eth, unsigned char mac_bytes[6]) ;
void print_usage(char *prog) ;


#endif
